import org.ejml.simple.SimpleMatrix;

public class ActivationLayer extends Layer {
    /* custom activation functions not yet supported
    Function<SimpleMatrix, SimpleMatrix> activation;
    Function<SimpleMatrix, SimpleMatrix> activationPrime;

    public ActivationLayer(Function<SimpleMatrix, SimpleMatrix> activation, Function<SimpleMatrix, SimpleMatrix> activationPrime) {
        this.activation = activation;
        this.activationPrime = activationPrime;
    }
    */

    public ActivationLayer() {}

    @Override
    public SimpleMatrix forwardPropagation(SimpleMatrix input) {
        this.input = input;
        this.output = tanh(input);
        return this.output;
    }

    @Override
    public SimpleMatrix backwardPropagation(SimpleMatrix outputError, double learningRate) {
        return tanhPrime(this.input).elementMult(outputError);
    }

    private SimpleMatrix tanh(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, Math.tanh(A.get(i)));
        }
        return B;
    }

    private SimpleMatrix tanhPrime(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, 1 - Math.pow(Math.tanh(A.get(i)), 2));
        }
        return B;
    }
}
